import groovy.sql.*;
import javax.sql.*;
import java.sql.*;
import org.apache.commons.dbcp.BasicDataSource;
import org.apache.commons.logging.*;
import java.util.Date;
import java.sql.Date;
import java.text.SimpleDateFormat;
import org.dom4j.*;
import org.dom4j.xpath.*;

	
//A SIMPLE FUNCTION TO SEE IF I'M RUNNIG THIS SCRIPT INSIDE ESB OR NOT
def String getMode(){
	
	if (this.binding.variables.containsKey("mode")){
		return this.binding.getVariable("mode");
	} else{
		return "esb";
	}
}



def DataSource getMetaDBDatasource(String jndiUri){	
	if (jndiUri == null){
		println "[ Test Mode Initialize datasource locally ]";
		BasicDataSource ds = new BasicDataSource();
		ds.setDriverClassName(this.binding['metadb.driver']);
		ds.setUsername(this.binding['metadb.user']);
		ds.setPassword(this.binding['metadb.password']);
		ds.setUrl(this.binding['metadb.url']);
		
		return ds;
	}else{
		 return (DataSource)(componentContext.getNamingContext().lookup(jndiUri));
	}
}


	
	def deleteDynamicData(Connection connection, String processName, String processVersion, java.sql.Date dataDa, java.sql.Date dataa ){
		groovy.sql.Sql db = new groovy.sql.Sql(connection);
		
		String selectProcessInstancesQuery = "SELECT i.id_process_instance FROM process_instance i"
		boolean whereAdded = false
				
		parList = [];
		if (processVersion != null || processName != null){
			selectProcessInstancesQuery += ", process s ";
		    selectProcessInstancesQuery += " WHERE i.id_process=s.id_process "
		    whereAdded = true;
			if (processName != null){
				selectProcessInstancesQuery += " AND s.name = ? ";
				parList += processName;
			}
			if (processVersion != null){
				selectProcessInstancesQuery += " AND  s.process_version = ? ";
				parList += processVersion;
			}
		}	

		if (dataDa != null){
			if (whereAdded){
					selectProcessInstancesQuery += " AND ";
			}else{
					selectProcessInstancesQuery += " WHERE ";
			}
		    whereAdded = true;
			selectProcessInstancesQuery += "i.enddate > ?";
			parList += dataDa;
		}
		
		if (dataa != null){
			if (whereAdded){
					selectProcessInstancesQuery += " AND ";
			}else{
					selectProcessInstancesQuery += " WHERE ";
			}
			selectProcessInstancesQuery += "i.enddate <= ? ";
			parList += dataa;
		}
		for (Object o : parList){
			println o;
		}
		print "Query["+selectProcessInstancesQuery+"]";
		
		
		
		
		// DELETE RELEVANT_DATA_INSTANCE_SA VALUES FOR GIVEN INSTANCE SA
		String deleteQuery1 = "DELETE FROM relevant_data_process_instance WHERE relevant_data_process_instance.id_process_instance = ?";
		
//		 DELETE RELEVANT_DATA_VALUE VALUES FOR GIVEN INSTANCE SA
		String selectForDeleteQuery2 = "SELECT rd.id_relevant_data "+
									   "FROM relevant_data rd, log_journal l, transition_instance j, process_instance i "+
									   "WHERE rd.id_log=l.id_log "+
									   "AND l.id_journal=j.id_journal "+
									   "AND j.id_process_instance=i.id_process_instance "+
									   "AND i.id_process_instance = ? ";
				  
		String deleteQuery2 = "DELETE FROM relevant_data WHERE relevant_data.id_relevant_data = ? ";
							  
		
		
		
		// DELETE LOG JOURNAL
		String selectForDeleteQuery3 = "SELECT lj.id_log "+
									   "FROM log_journal lj, transition_instance j, process_instance i "+
									   "WHERE lj.id_journal=j.id_journal "+
									   "AND j.id_process_instance=i.id_process_instance "+
									   "AND i.id_process_instance = ? ";
		
		String deleteQuery3 = "DELETE FROM log_journal WHERE log_journal.id_log = ? ";
		  					   
							   

		// DELETE JOURNAL INSTANCE SERVICE
		String selectForDeleteQuery4 = "SELECT jis.id_journal FROM  transition_instance jis, process_instance i "+
		  							   "WHERE jis.id_process_instance=i.id_process_instance "+
		  							   "AND i.id_process_instance = ?";
		
		String deleteQuery4 = "DELETE FROM transition_instance WHERE transition_instance.id_journal = ? ";
		
		//DELETE INSTANCE_SA
		String deleteQuery5 ="DELETE FROM process_instance WHERE process_instance.id_process_instance = ?";
		
		
		rows = db.rows(selectProcessInstancesQuery, parList);
		
		println "Retrieved ["+rows.size() +"] instances "
	
		parListDelete = [];
		
		for ( aRow in rows ){
		
			parListDelete.clear();
			parListDelete += aRow[0];
			println "---- DELETING DINAMIC DATA FOR PROCESS INSTANCES ["+aRow[0]+"] ---- ";
			
			int res = db.executeUpdate(deleteQuery1, parListDelete);
			println "DELETED  ["+res+"] rows from relevant_data_process_instance table"
			
			db.eachRow(selectForDeleteQuery2, parListDelete){
				db.executeUpdate(deleteQuery2,[it.id_relevant_data]);
			}
			println "DELETED rows from relevant_data table"
			
			
			db.eachRow(selectForDeleteQuery3, parListDelete){
				db.executeUpdate(deleteQuery3,[it.id_log]);
			}
			println "DELETED rows from log_journal table"
			
			
			db.eachRow(selectForDeleteQuery4, parListDelete){
				db.executeUpdate(deleteQuery4,[it.id_journal]);
			}
			
			println "DELETED rows from transition_instance table"
			
			
			res = db.executeUpdate(deleteQuery5, parListDelete);
			println "DELETED ["+res+"] rows from process_instance table";
			
		}
}
	
//	 MAIN SCRIPT
	String modeScript = getMode();
	println "Running in ["+modeScript+"]";
	
	def SimpleDateFormat fmt = new java.text.SimpleDateFormat("dd/MM/yyyy");
	
	// DEFINE PARAMETERS
	def String parProcessName = null;
	def String parProcessVersionString = null;
	def String parFromDateString = null;
	def java.sql.Date parFromDate = null; 
	def String parToDateString = null;
	def java.sql.Date parToDate = null;
	
	def String xmlInput  = null;
	
	// GETTING INPUT FROM BINDING OR FROM MESSAGE-CONTENT
	if (modeScript == "standalone"){
		println "Getting xml input messages string from Bindinf variable 'xmlInputMessage'";
		xmlInput = this.binding['xmlInputMessage'];
	}else{ // esb
		println "Getting xml input messages string from Message Content ";
		xmlInput = new String(inMessage.bodyText);
	}
	
	// PARSE THE INPUT TO GET PARAMETERS
	def org.dom4j.Document document = DocumentHelper.parseText(xmlInput);
	parProcessName = document.valueOf("/parameters/@processName")
	parProcessVersionString = document.valueOf("/parameters/@processVersion"); 
	parFromDateString = document.valueOf("/parameters/@fromDate");
	parToDateString = document.valueOf("/parameters/@toDate");
	
	if (parProcessName != null && parProcessName.trim().length() == 0){
		println "parProcessName -> is empty set to null";
		parProcessName=null;
	}
	
	if (parProcessVersionString != null && parProcessVersionString.trim().length() == 0){
		println "parProcessVersionString -> is empty set to null";
		parProcessVersionString=null;
	}
	
	if (parFromDateString != null && parFromDateString.trim().length() == 0){
		println "parFromDateString -> is empty set to null";
		parFromDateString=null;
	}
	
	if (parToDateString != null && parToDateString.trim().length() == 0){
		println "parToDateString -> is empty set to null";
		parToDateString=null;
	}
	
	if (parFromDateString != null){
		java.util.Date tmp = (java.util.Date)fmt.parse(parFromDateString);
		parFromDate = new java.sql.Date(tmp.getTime());
	}
	if (parToDateString != null){
		java.util.Date tmp2 = (java.util.Date)fmt.parse(parToDateString);
		parToDate = new java.sql.Date(tmp2.getTime());
	}
	
	DataSource ds = null;

	
	if (mode == "esb"){
		ds = getMetaDBDatasource("java:comp/env/jdbc/metadb");
		
	}else{
		ds = getMetaDBDatasource(null);
		
	}
	
	
	Connection connection = null;
	
	
	try{
		connection = ds.getConnection();
		connection.autoCommit = false;
		deleteDynamicData(connection, parProcessName, parProcessVersionString, parFromDate,parToDate );
		connection.commit();
		if (modeScript == "esb"){
			outMessage.bodyText = "<OK> Delete OK </OK>";
		}
	}catch(Exception e){
		println e;
		if (connection != null){	
			connection.rollback();
		}
		if (modeScript == "esb"){
			outMessage.bodyText = "<ERROR> "+e.getMessage()+"</ERROR>";
		}
	}finally{
		if (connection != null){
			connection.close();
		}
	}



