import groovy.sql.*;
import javax.sql.*;
import java.sql.*;
import org.apache.commons.dbcp.BasicDataSource;
import org.apache.commons.logging.*;
import org.dom4j.*;
import org.dom4j.xpath.*;

	
//A SIMPLE FUNCTION TO SEE IF I'M RUNNIG THIS SCRIPT INSIDE ESB OR NOT
def String getMode(){
	
	if (this.binding.variables.containsKey("mode")){
		return this.binding.getVariable("mode");
	} else{
		return "esb";
	}
}



def DataSource getMetaDBDatasource(String jndiUri){	
	if (jndiUri == null){
		println "[ Test Mode Initialize datasource locally ]";
		BasicDataSource ds = new BasicDataSource();
		ds.setDriverClassName(this.binding['metadb.driver']);
		ds.setUsername(this.binding['metadb.user']);
		ds.setPassword(this.binding['metadb.password']);
		ds.setUrl(this.binding['metadb.url']);
		
		return ds;
	}else{
		 return (DataSource)(componentContext.getNamingContext().lookup(jndiUri));
	}
}


	
	def deleteStaticData(Connection connection, String processName, String processVersion){
		groovy.sql.Sql db = new groovy.sql.Sql(connection);
		
		String selectProcessQuery = "SELECT p.id_process FROM process p"
		boolean addEnd = false;
				
		parList = [];
		if (processVersion != null || processName != null){
		    selectProcessQuery += " WHERE "
			if (processName != null){
				addEnd = true;
				selectProcessQuery += " p.name = ? ";
				parList += processName;
			}
			if (processVersion != null){
				if (addEnd)
					selectProcessQuery += " AND ";
				selectProcessQuery += " p.process_version = ? ";
				parList += processVersion;
			}
		}	
		
		for (Object o : parList){
			println o;
		}
		print "Query["+selectProcessQuery+"]";
		
		String selectStep = "SELECT id_step FROM step WHERE id_process = ?";
		String deletePropertyStep = "DELETE FROM property_step WHERE id_step = ?";
		String deleteTransition = "DELETE FROM transition WHERE id_process = ?";
		String deleteStepRule = "DELETE FROM step_rule WHERE id_step = ?";
		String deleteStep = "DELETE FROM step WHERE id_process = ?";
		String deletePropertyProcess = "DELETE FROM property_process WHERE id_process = ?";
		String deleteProcessDiagram = "DELETE FROM process_diagram WHERE id_process = ?";
		String deletePoolTypeProcess = "DELETE FROM pool_type_process WHERE id_process = ?";
		String deleteProcess = "DELETE FROM process WHERE id_process = ?";
				  					   				
		rows = db.rows(selectProcessQuery, parList);
		
		println "Retrieved ["+rows.size() +"] instances "
	
		parListDelete = [];
		
		for ( aRow in rows ){
		
			parListDelete.clear();
			parListDelete += aRow[0];
			println "---- DELETING STATIC DATA FOR PROCESS ["+aRow[0]+"] ---- ";
			
			db.eachRow(selectStep, parListDelete){
				db.executeUpdate(deletePropertyStep,[it.id_step]);
			}
			println "DELETED rows from property_step table"
			
			res = db.executeUpdate(deleteTransition, parListDelete);
			println "DELETED  ["+res+"] rows from transition table"
			
			db.eachRow(selectStep, parListDelete){
				db.executeUpdate(deleteStepRule,[it.id_step]);
			}
			println "DELETED rows from step_rule table"
			
			res = db.executeUpdate(deleteStep, parListDelete);
			println "DELETED  ["+res+"] rows from step table"
			
			res = db.executeUpdate(deletePropertyProcess, parListDelete);
			println "DELETED  ["+res+"] rows from property_process table"
			
			res = db.executeUpdate(deleteProcessDiagram, parListDelete);
			println "DELETED  ["+res+"] rows from process_diagram table"
			
			res = db.executeUpdate(deletePoolTypeProcess, parListDelete);
			println "DELETED  ["+res+"] rows from pool_type_process table"
			
			res = db.executeUpdate(deleteProcess, parListDelete);
			println "DELETED  ["+res+"] rows from process table"
		}
}
	
//	 MAIN SCRIPT
	String modeScript = getMode();
	println "Running in ["+modeScript+"]";
	
	// DEFINE PARAMETERS
	def String parProcessName = null;
	def String parProcessVersionString = null;
	def String xmlInput  = null;
	
	// GETTING INPUT FROM BINDING OR FROM MESSAGE-CONTENT
	if (modeScript == "standalone"){
		println "Getting xml input messages string from Bindinf variable 'xmlInputMessage'";
		xmlInput = this.binding['xmlInputMessage'];
	}else{ // esb
		println "Getting xml input messages string from Message Content ";
		xmlInput = new String(inMessage.bodyText);
	}
	
	// PARSE THE INPUT TO GET PARAMETERS
	def org.dom4j.Document document = DocumentHelper.parseText(xmlInput);
	parProcessName = document.valueOf("/parameters/@processName")
	parProcessVersionString = document.valueOf("/parameters/@processVersion"); 
	
	if (parProcessName != null && parProcessName.trim().length() == 0){
		println "parProcessName -> is empty set to null";
		parProcessName=null;
	}
	
	if (parProcessVersionString != null && parProcessVersionString.trim().length() == 0){
		println "parProcessVersionString -> is empty set to null";
		parProcessVersionString=null;
	}
	
	DataSource ds = null;
	
	if (mode == "esb")
		ds = getMetaDBDatasource("java:comp/env/jdbc/metadb");
	else
		ds = getMetaDBDatasource(null);
	
	Connection connection = null;
	try{
		connection = ds.getConnection();
		connection.autoCommit = false;
		deleteStaticData(connection, parProcessName, parProcessVersionString);
		connection.commit();
		if (modeScript == "esb"){
			outMessage.bodyText = "<OK> Delete OK </OK>";
		}
	}catch(Exception e){
		println e;
		if (connection != null){	
			connection.rollback();
		}
		if (modeScript == "esb"){
			outMessage.bodyText = "<ERROR> "+e.getMessage()+"</ERROR>";
		}
	}finally{
		if (connection != null){
			connection.close();
		}
	}



